---------------------- Information from the mail header -----------------------
--Sender:       Euphoria Programming for MS-DOS <EUPHORIA@MIAMIU.ACS.MUOHIO.EDU>
--Poster:       Michael Bolin <michaeltom@GEOCITIES.COM>
--Subject:      GIF loader bug fix
--Sent:         Sunday, September 28, 1997 2:21 PM
-------------------------------------------------------------------------------
-- Hi all,
-- I've just fixed my PCX loader routine to be able to load files which
-- use a non-standard method of indicating the color depth.


-- Tweaked version (uses "pointers" instead of sequences)
-- /Mic, 000803


include machine.e
include file.e
 
global constant PCX_OPEN_FAILED=1,
		PCX_UNEXPECTED_EOF=2,
		PCX_UNSUPPORTED_FORMAT=3,
		GIF_OPEN_FAILED=1,
		GIF_UNEXPECTED_EOF=2,
		GIF_UNSUPPORTED_FORMAT=3
 
object junk
sequence image,the_palette,bit_table
integer file_num,exit_flag,palette_at_end
integer x_size,y_size,bits_per_pixel,n_colors
integer background,bytes_per_line,x_min,x_max
integer y_min,y_max,n_planes
 
bit_table=repeat({},256)
for n=0 to 255 do
    bit_table[n+1]=int_to_bits(n,8)
end for

----- Data from save_pic.e ------------------------------------------------
integer stat_bits
atom code_in_progress
sequence hashtree,LZW

constant powers2={#1,#2,#4,#8,#10,#20,#40,#80,#100,#200,#400,#800,#1000,#2000,
                  #4000,#8000,#10000,#20000,#40000,#80000,#100000,#200000,
                  #400000,#800000},
         hash=11003
---------------------------------------------------------------------------


 
function read_bytes(integer amount)
    sequence bytes
 
    bytes=repeat(0,amount)
    for b=1 to amount do
	bytes[b]=getc(file_num)
	if bytes[b]=-1 then
	    exit_flag=GIF_UNEXPECTED_EOF
	end if
    end for
    return bytes
end function
 
function bytes_left()
    integer place,end_place
 
    place=where(file_num)
    if seek(file_num,-1)=0 then
	end_place=where(file_num)
	if seek(file_num,place)=0 then
	    return end_place-place
	else
	    return -1
	end if
    else
	return -1
    end if
end function
 
-- procedure read_pcx_header()
--  if bytes_left()<128 then
--      exit_flag=PCX_UNEXPECTED_EOF
--      return
--  end if
--  junk=getc(file_num)
--  palette_at_end=0
--  if getc(file_num)=5 then
--      palette_at_end=1
--  end if
--  if getc(file_num)!=1 then
--      exit_flag=PCX_UNSUPPORTED_FORMAT
--      return
--  end if
--  bits_per_pixel=getc(file_num)
--  if bits_per_pixel!=1 and bits_per_pixel!=8 then
--      exit_flag=PCX_UNSUPPORTED_FORMAT
--      return
--  end if
--  x_min=getc(file_num)+getc(file_num)*256
--  y_min=getc(file_num)+getc(file_num)*256
--  x_max=getc(file_num)+getc(file_num)*256
--  y_max=getc(file_num)+getc(file_num)*256
--  x_size=x_max-x_min+1
--  y_size=y_max-y_min+1
--  junk=read_bytes(4)
--  the_palette={}
--  if palette_at_end then
--      junk=read_bytes(48)
--  else
--      for c=1 to 16 do
--          the_palette=append(the_palette,read_bytes(3))
--      end for
--  end if
--  if exit_flag then
--      return
--  end if
--  if getc(file_num) then
--      exit_flag=PCX_UNSUPPORTED_FORMAT
--      return
--  end if
--  n_planes=getc(file_num)
--  bytes_per_line=getc(file_num)+getc(file_num)*256
--  junk=read_bytes(6)
--  for x=1 to 54 do
--      junk=getc(file_num)
--      if junk=-1 then
--          exit_flag=PCX_UNEXPECTED_EOF
--          return
--      elsif junk then
--          exit_flag=PCX_UNSUPPORTED_FORMAT
--          return
--      end if
--  end for
-- end procedure
procedure read_pcx_header()    -- updated Sep. 28/97
    if bytes_left()<128 then
	exit_flag=PCX_UNEXPECTED_EOF
	return
    end if
    junk=getc(file_num)
    palette_at_end=0
    if getc(file_num)=5 then
	palette_at_end=1
    end if
    if getc(file_num)!=1 then
	exit_flag=PCX_UNSUPPORTED_FORMAT
	return
    end if
    bits_per_pixel=getc(file_num)
    if bits_per_pixel!=1 and bits_per_pixel!=8 then
	exit_flag=PCX_UNSUPPORTED_FORMAT
	return
    end if
    if bits_per_pixel=1 then
	palette_at_end=0
    end if
    x_min=getc(file_num)+getc(file_num)*256
    y_min=getc(file_num)+getc(file_num)*256
    x_max=getc(file_num)+getc(file_num)*256
    y_max=getc(file_num)+getc(file_num)*256
    x_size=x_max-x_min+1
    y_size=y_max-y_min+1
    junk=read_bytes(4)
    the_palette={}
    if palette_at_end then
	junk=read_bytes(48)
    else
	for c=1 to 16 do
	    the_palette=append(the_palette,read_bytes(3))
	end for
    end if
    if exit_flag then
	return
    end if
    if getc(file_num) then
	exit_flag=PCX_UNSUPPORTED_FORMAT
	return
    end if
    n_planes=getc(file_num)
    bytes_per_line=getc(file_num)+getc(file_num)*256
    junk=read_bytes(6)
    for x=1 to 54 do
	junk=getc(file_num)
	if junk=-1 then
	    exit_flag=PCX_UNEXPECTED_EOF
	    return
	elsif junk then
	    exit_flag=PCX_UNSUPPORTED_FORMAT
	    return
	end if
    end for
end procedure

function read_pcx_image()
    sequence one_row,bits,new_row
    integer number,byte,line,count,and_value,place
    integer plane_power,amount
    atom pcx

    --image=repeat({},y_size)
    pcx = allocate(x_size*y_size)
    one_row=repeat(0,bytes_per_line*n_planes)
    line=1
    while line<=y_size do
	number=1
	while number<=length(one_row) do
	    byte=getc(file_num)
	    if byte=-1 then
		exit_flag=PCX_UNEXPECTED_EOF
		return 0
	    end if
	    if byte>191 then
		count=byte-193
		byte=getc(file_num)
		if byte=-1 then
		    exit_flag=PCX_UNEXPECTED_EOF
		    return 0
		end if
		one_row[number..number+count]=byte
		number=number+count+1
	    else
		one_row[number]=byte
		number=number+1
	    end if
	end while
	if bits_per_pixel=1 then
	    bits=repeat(0,bytes_per_line*8*n_planes)
	    place=1
	    for p=0 to n_planes-1 do
		plane_power=power(2,p)
		for t=1 to bytes_per_line do
		    byte=one_row[p*bytes_per_line+t]
		    and_value=256
		    for z=1 to 8 do
			and_value=and_value/2
			if and_bits(byte,and_value) then
			    bits[place]=plane_power
			end if
			place=place+1
		    end for
		end for
	    end for
	    amount=bytes_per_line*8
	    new_row=bits[1..amount]
	    for p=1 to n_planes-1 do
		new_row=new_row+bits[amount*p+1..amount*(p+1)]
	    end for
	    if length(new_row)>x_size then
		new_row=new_row[1..x_size]
	    end if
	else
	    new_row=one_row
	end if
--	image[line]=new_row
        poke(pcx+((line-1)*x_size),new_row)
	line=line+1
    end while
    if palette_at_end then
	junk=getc(file_num)
	for c=1 to 256 do
	    the_palette=append(the_palette,read_bytes(3))
	    if find(-1,the_palette[c]) then
		exit_flag=PCX_UNEXPECTED_EOF
		return 0
	    end if
	end for
    end if
  return pcx
end function

 
procedure read_gif_header()
    object work
    sequence stuff,bits
    integer global_color_map
 
    if bytes_left()<6 then
	exit_flag=GIF_UNEXPECTED_EOF
	return
    end if
    stuff=read_bytes(3)
    if compare(stuff,"GIF") and compare(stuff,"GIF") then
	exit_flag=GIF_UNSUPPORTED_FORMAT
	return
    end if
    junk=read_bytes(3)
    if bytes_left()<7 then
	exit_flag=GIF_UNEXPECTED_EOF
	return
    end if
    junk=read_bytes(4)
    bits=bit_table[getc(file_num)+1]
    global_color_map=bits[8]
    bits_per_pixel=bits_to_int(bits[1..3])+1
    n_colors=power(2,bits_per_pixel)
    background=getc(file_num)
    junk=getc(file_num)
    the_palette={}
    if global_color_map then
	if bytes_left()<n_colors*3 then
	    exit_flag=GIF_UNEXPECTED_EOF
	    return
	end if
	for c=1 to n_colors do
	    the_palette=append(the_palette,read_bytes(3))
	end for
    end if
    while 1 do
	work=getc(file_num)
	if work=-1 then
	    exit_flag=GIF_UNEXPECTED_EOF
	    return
	elsif work=',' then
	    exit
	end if
    end while
end procedure

 
function read_gif_image()
    object work
    sequence strings,bits,output,work_bits,string,stream
    integer interlace,code_size,clear_code,end_of_info
    integer num_bits,code,old,done,pointer,block_length
    integer bit_add
    atom gif
 
    if bytes_left()<9 then
	exit_flag=GIF_UNEXPECTED_EOF
	return 0
    end if
    junk=read_bytes(4)
    x_size=getc(file_num)+getc(file_num)*256
    y_size=getc(file_num)+getc(file_num)*256
    work=getc(file_num)
    bits=bit_table[work+1]
    if bits[8] then
	bits_per_pixel=bits_to_int(bits[1..3])+1
	n_colors=power(2,bits_per_pixel)
	the_palette={}
	for c=1 to n_colors do
	    the_palette=append(the_palette,read_bytes(3))
	end for
	if exit_flag then
	    return 0
	end if
    end if
    interlace=bits[7]
    --image=repeat({},y_size)
    output={}
    if n_colors=2 then
	n_colors=4
    end if
    strings=repeat({},n_colors+2)
    for t=1 to n_colors do
	strings[t]={t-1}
    end for
    code_size=getc(file_num)
    if code_size=-1 then
	exit_flag=GIF_UNEXPECTED_EOF
	return 0
    end if
    clear_code=power(2,code_size)+1
    end_of_info=clear_code+1
    num_bits=code_size+1
    stream={}
    while 1 do
	block_length=getc(file_num)
	if block_length=0 then
	    exit
	end if
	for b=1 to block_length do
	    stream=append(stream,getc(file_num))
	end for
    end while
    if find(-1,stream) then
	exit_flag=GIF_UNEXPECTED_EOF
	return 0
    end if
    stream=append(stream,0)
    stream=append(stream,-1)
    pointer=1
    bits={}
    while length(bits)<26 do
	bits=bits & bit_table[stream[pointer]+1]
	pointer=pointer+1
    end while
    bits=bits[num_bits+1..length(bits)]
    work_bits=bits[1..num_bits]
    code=bits_to_int(work_bits)+1
    output=strings[code]
    old=code
    bits=bits[num_bits+1..length(bits)]
    done=0
    while 1 do
	while length(bits)<26 and done=0 do
	    work=stream[pointer]
	    pointer=pointer+1
	    if work=-1 then
		done=1
		exit
	    end if
	    bits=bits & bit_table[work+1]
	end while
	if length(bits)<num_bits then
	    exit
	end if
	code=1
	bit_add=1
	for b=1 to num_bits do
	    if bits[b] then
		code=code+bit_add
	    end if
	    bit_add=bit_add+bit_add
	end for
	bits=bits[num_bits+1..length(bits)]
	if code=end_of_info then
	    exit
	elsif code=clear_code then
	    strings=repeat({},n_colors+2)
	    for t=1 to n_colors do
		strings[t]={t-1}
	    end for
	    num_bits=code_size+1
	    work_bits=bits[1..num_bits]
	    code=bits_to_int(work_bits)+1
	    for t=1 to length(strings[code]) do
		output=append(output,strings[code][t])
	    end for
	    old=code
	    bits=bits[num_bits+1..length(bits)]
	else
	    if code<=length(strings) then
		string=strings[code]
		for t=1 to length(string) do
		    output=append(output,string[t])
		end for
		work=strings[old] & string[1]
		strings=append(strings,work)
		old=code
	    else
		work=strings[old] & strings[old][1]
		for t=1 to length(work) do
		    output=append(output,work[t])
		end for
		strings=append(strings,work)
		old=code
	    end if
	end if
	if length(strings)=power(2,num_bits) then
	    num_bits=num_bits+1
	    if num_bits=13 then
		num_bits=12
	    end if
	end if
    end while
    gif = allocate( x_size*y_size )
    work=repeat({},y_size)
    for r=0 to y_size-1 do
	work[r+1]=output[r*x_size+1..r*x_size+x_size]
    end for
    if interlace then
	image=repeat({},y_size)
	pointer=1
	for l=1 to y_size by 8 do
	    --image[l]=work[pointer]
            poke(gif+((l-1)*x_size),work[pointer])
	    pointer=pointer+1
	end for
	for l=5 to y_size by 8 do
--	    image[l]=work[pointer]
            poke(gif+((l-1)*x_size),work[pointer])
	    pointer=pointer+1
	end for
	for l=3 to y_size by 4 do
--	    image[l]=work[pointer]
            poke(gif+((l-1)*x_size),work[pointer])
  	    pointer=pointer+1
	end for
	for l=2 to y_size by 2 do
--	    image[l]=work[pointer]
            poke(gif+((l-1)*x_size),work[pointer])
	    pointer=pointer+1
	end for
    else
        for l=0 to y_size-1 do
          poke(gif+(l*x_size),work[l+1])
        end for
--	image=work
    end if
    return gif
end function

 
global function read_pcx(sequence filename)
atom a
    exit_flag=0
    file_num=open(filename,"rb")
    if file_num<0 then
	return PCX_OPEN_FAILED
    end if
    read_pcx_header()
    if exit_flag then
	close(file_num)
	return exit_flag
    end if
    a = read_pcx_image()
    close(file_num)
    if exit_flag then
	return exit_flag
    end if
    the_palette=the_palette[1..power(2,bits_per_pixel*n_planes)]
--    return {the_palette,image}
    return {a,x_size,y_size,8,0,the_palette}
end function

 
global function read_gif(sequence file_name)
atom a
    exit_flag=0
    file_num=open(file_name,"rb")
    if file_num<0 then
	return GIF_OPEN_FAILED
    end if
    read_gif_header()
    if exit_flag then
	close(file_num)
	return exit_flag
    end if
    a = read_gif_image()
    close(file_num)
    if not a then
      return {0,0,0,0,exit_flag,0}
    end if
    if exit_flag then
	return exit_flag
    end if
    --return {the_palette,image}
    return {a,x_size,y_size,8,0,the_palette}
end function

----- END load_pic.e -----------------------------------------------------







----- BEGIN save_pic.e -----------------------------------------------------


function lowhi(integer i)
    return remainder(i,256)&floor(i/256)
end function

function find_hash(integer pre,integer suf)
    integer i,o
    i=remainder(xor_bits((pre*256),suf),hash)
    if i=0 then
        o=1
    else
        o=hash-i
    end if
    while 1 do
        if hashtree[i+1][1]=-1 then
            return i+1
        elsif hashtree[i+1][2]=pre and hashtree[i+1][3]=suf then
            return i+1
        else
            i=i-o
            if i<0 then
                i=i+hash
            end if
        end if
    end while
end function

function max_bits(integer num)
    for i=1 to 14 do
        if powers2[i]>=num then
            return i-1
        end if
    end for
end function

procedure append_code(integer handle,integer code)
    LZW=LZW&code
    if length(LZW)=255 then
        puts(handle,255&LZW)
        LZW={}
    end if
end procedure

procedure write_code(integer handle,integer no_bits,integer code)
    code_in_progress=code_in_progress+code*powers2[stat_bits+1]
    stat_bits=stat_bits+no_bits
    while stat_bits>7 do
        append_code(handle,and_bits(code_in_progress,255))
        code_in_progress=floor(code_in_progress/256)
        stat_bits=stat_bits-8
    end while
end procedure

function GIF_LZW_compressor(sequence pic,sequence gifpal,integer handle,
                            integer interlace)
    integer xdim,ydim,clear,EOI,code,bits,pre,suf,x,y,i,max,bits_color,done
    sequence rasters
    --trace(1)
    stat_bits = 0
    code_in_progress = 0
    LZW = {}
    hashtree = repeat({-1,-1,-1},hash)
    if handle=-1 then
        return 0
    end if
    xdim = pic[2]
    ydim = pic[3]
    bits_color = max_bits(length(gifpal))-1
    clear = powers2[bits_color+2]
    EOI = clear+1
    code = EOI+1
    bits = bits_color+2
    max = powers2[bits+1]
    if code=max then
        clear = 4
        EOI = 5
        code = 6
        bits += 1
        max *= 2
    end if
    puts(handle,bits-1)    
    write_code(handle,bits,clear)
    rasters = {}
    if interlace then
        for e=1 to 5 by 4 do
            for f=e to ydim by 8 do
                rasters=rasters&f
            end for
        end for
        for e=3 to ydim by 4 do
            rasters=rasters&e
        end for
        for e=2 to ydim by 2 do
            rasters=rasters&e
        end for
    else
        for e=1 to ydim do
            rasters=rasters&e
        end for        
    end if
--    pre = pic[rasters[1]][1]
    pre = peek(pic[1]+((rasters[1]-1)*pic[2]))
    x = 2     y = 1     done = 0
    if x>xdim then  y += 1   x = 1 end if
    while 1 do
        while 1 do
            if not done then
--                suf=pic[rasters[y]][x]
                suf = peek(pic[1]+((rasters[y]-1)*pic[2])+(x-1))
                x += 1
                if x>xdim then
                    y += 1
                    x = 1
                    if y>ydim then
                        done = 1
                    end if
                end if
                i=find_hash(pre,suf)
                if hashtree[i][1]=-1 then
                    exit
                else
                    pre = hashtree[i][1]
                end if
            else                
                write_code(handle,bits,pre)
                write_code(handle,bits,EOI)
                if stat_bits then
                    write_code(handle,bits,0)
                end if
                puts(handle,length(LZW)&LZW)
                puts(handle,0)
                hashtree = {}
                return 1
            end if
        end while
        write_code(handle,bits,pre)
        hashtree[i] = {code,pre,suf}
        pre = suf        
        code += 1
        if code=max+1 then
            max *= 2
            if bits=12 then
                write_code(handle,bits,clear)
                hashtree = repeat({-1,-1,-1},hash)
                code = EOI+1
                bits = bits_color+2
                max = powers2[bits+1]
                if bits=2 then
                    clear = 4
                    EOI = 5
                    code = 6
                    bits = 3
                    max *=2
                end if
            else
                bits += 1
            end if
        end if
    end while
end function

global function save_gif(sequence pic,sequence filename)
    integer bits_color,i,handle,xdim,ydim
    xdim=length(pic[2][1])
    ydim=length(pic[2])
    handle=open(filename,"wb")
    bits_color=max_bits(length(pic[1]))-1
    puts(handle,"GIF87a")
    puts(handle,remainder(xdim,256)&floor(xdim/256))
    puts(handle,remainder(ydim,256)&floor(ydim/256))
    puts(handle,208+bits_color&0&0)
    if length(pic[1])<powers2[bits_color+2] then
        pic[1]=append(pic[1],repeat({0,0,0},powers2[bits_color+2]-length(pic[1])))
    end if
    for e=1 to length(pic[1]) do
        puts(handle,pic[1][e][1..3])
    end for
    puts(handle,','&0&0&0&0&remainder(xdim,256)&floor(xdim/256))
    puts(handle,remainder(ydim,256)&floor(ydim/256)&bits_color)
    i=GIF_LZW_compressor(pic[2],pic[1],handle,0)
    puts(handle,';'&repeat(#1A,8))
    close(handle)
    return i
end function

global function extended_save_gif(sequence pic,sequence filename,
                                  object interlace,sequence comment,sequence
                                  pos)
    integer bits_color,i,handle,xdim,ydim,no_pics
    sequence LSD                --- that's L)ogical S)creen D)escriptor
    sequence gifpal 
    --atom gif
    handle = open(filename,"wb")
    if handle=-1 then
        return 3
    end if
    --if sequence(pic[1][1][1]) then
    --    no_pics=length(pic)
    --    bits_color=max_bits(length(pic[1][1]))-1
    --else
        no_pics=1
        --pic={pic}
        --gif = pic[1]
        gifpal = pic[6]
        bits_color = max_bits(length(gifpal))-1
    --end if
    if length(pos) and length(pos)!=no_pics then
        return 0
    end if
    if no_pics>1 then
        if length(pos)<no_pics then
            return 0
        end if
        LSD={0,0}
        for e=1 to no_pics do
            if length(pic[e][2][1])+pos[e][1]-1>LSD[1] then
                LSD[1]=length(pic[e][2][1])+pos[e][1]-1
            end if
            if length(pic[e][2])+pos[e][2]-1>LSD[2] then
                LSD[2]=length(pic[e][2][2])+pos[e][2]-1
            end if
        end for
    else
        --if length(pos) then
        --    LSD={length(pic[1][2][1])+pos[1][1],length(pic[1][2])+pos[1][2]}
        --else
            LSD = {pic[2],pic[3]}
        --end if
    end if
    xdim = LSD[1]     ydim = LSD[2]         LSD = {}
    if sequence(interlace) then
        if length(interlace)!=no_pics then
            return 0
        end if
    end if
    puts(handle,"GIF89a")
    puts(handle,remainder(xdim,256)&floor(xdim/256))
    puts(handle,remainder(ydim,256)&floor(ydim/256))
    if no_pics=1 then
        puts(handle,208+bits_color&0&0)
        if length(gifpal)<powers2[bits_color+2] then
            gifpal=append(gifpal,repeat({0,0,0},powers2[bits_color+2]-length(gifpal)))
        end if
        for e=1 to length(gifpal) do
            puts(handle,gifpal[e][1..3])
        end for
    else
        puts(handle,80+bits_color&0&0)
    end if
    for e=1 to no_pics do
        bits_color = max_bits(length(gifpal))-1
        xdim = pic[2]
        ydim = pic[3]
        if no_pics=1 then
            if not length(pos) then
                puts(handle,','&0&0&0&0&lowhi(xdim)&lowhi(ydim))
            else
                puts(handle,','&lowhi(pos[e][1])&lowhi(pos[e][2])&lowhi(xdim)&lowhi(ydim))
            end if
            if sequence(interlace) then
                puts(handle,bits_color+(64*(interlace[1]!=0)))
            else
                puts(handle,bits_color+(64*(interlace!=0)))
            end if
        else
            puts(handle,','&lowhi(pos[e][1])&lowhi(pos[e][2])&lowhi(xdim)&lowhi(ydim))
            if sequence(interlace) then
                puts(handle,bits_color+128+(64*(interlace[e]!=0)))
            else
                puts(handle,bits_color+128+(64*(interlace!=0)))
            end if
            if length(pic[e][1])<powers2[bits_color+2] then
                pic[e][1]=append(pic[e][1],repeat({0,0,0},powers2[bits_color+2]-length(pic[e][1])))
            end if
            for f=1 to length(pic[e][1]) do
                puts(handle,pic[e][1][f][1..3])
            end for
        end if
        if sequence(interlace) then
            i=GIF_LZW_compressor(pic,gifpal,handle,interlace[e])
        else
            i=GIF_LZW_compressor(pic,gifpal,handle,interlace)
        end if
    end for

    if length(comment) then
        puts(handle,#21&#FE)
        while length(comment)>255 do
            puts(handle,#FF&comment[1..255])
            comment=comment[256..length(comment)]
        end while
        puts(handle,length(comment)&comment&0)
    end if
    puts(handle,';'&repeat(#1A,8))
    close(handle)    
    return i
end function


global function save_pcx(sequence pic,sequence filename)
    integer handle,xdim,ydim,t,i,j,zerotrail
    atom pcx
    sequence pcxpal
    pcxpal = pic[6]
    pcx = pic[1]
    handle = open(filename,"wb")
    if handle=-1 then
        return 0
    end if
    -- Lots of secret header stuff
    xdim = pic[2]
    ydim = pic[3]
    zerotrail = 0
    if remainder(xdim,2) then
        --for e=1 to ydim do
        --    pic[e]=pic[e]&0
        --end for
        zerotrail = 1
        --xdim += 1
    end if
    puts(handle,10&5&1&8&0&0&0&0)
    puts(handle,remainder((xdim+zerotrail)-1,256)&floor(((xdim+zerotrail)-1)/256))
    puts(handle,remainder(ydim-1,256)&floor((ydim-1)/256))
    puts(handle,remainder((xdim+zerotrail),256)&floor((xdim+zerotrail)/256))
    puts(handle,remainder(ydim,256)&floor(ydim/256))
    puts(handle,0&0&0&216&152&56&120&116&4&112&108&4&236&
                172&76&248&196&128&64&36&36&36&40&20&248&
                188&104&212&144&156&60&36&36&116&112&8&
                120&116&8&124&120&8&52&48&4&240&196&136)
    puts(handle,0&1&remainder((xdim+zerotrail),256)&floor((xdim+zerotrail)/256)&1&0&0&0&0&0&repeat(0,54))
    -- Actual pic encoding
    i=0     j=0
    while 1 do
        t=1
        if (i+1)<xdim then
            while peek(pcx+(j*xdim)+i)=peek(pcx+(j*xdim)+i+1) do
                i += 1       t += 1
                if t=63 then exit end if
                if (i+1)=xdim then i-=1 t-=1 exit end if
            end while
        end if
        if t=1 then
            if and_bits(peek(pcx+(j*xdim)+i),192)=192 then
                puts(handle,193)
            end if
            puts(handle,peek(pcx+(j*xdim)+i))
        else
            puts(handle,t+192&peek(pcx+(j*xdim)+i))
        end if
        i += 1
        if i=xdim then
            i = 0
            j += 1
            if zerotrail then puts(handle,0) end if
        end if
        if j=ydim then
            exit
        end if
    end while
    puts(handle,12)
    for e = 1 to length(pcxpal) do
        puts(handle,pcxpal[e][1..3])
    end for
    if length(pcxpal)<256 then
        for e=1 to 256-length(pcxpal) do
            puts(handle,{0,0,0})
        end for
    end if
    close(handle)
    return 1
end function


global function save_targa(sequence pic,sequence filename,integer RLE)
    integer handle,index,i,x,c,last,mode
    sequence bytes,data
    handle=open(filename,"wb")
    if handle=-1 then
        return 0
    end if
    index=1
    if length(pic)!=2 then
        index=0
    end if
    if not RLE then
        if index then
            bytes={0,1,1,0,0}&lowhi(length(pic[1]))&24&0&0&0&0&
                lowhi(length(pic[2][1]))&lowhi(length(pic[2]))&8&0
            puts(handle,bytes)
            for e=1 to length(pic[1]) do
                i=pic[1][e][3]
                pic[1][e][3]=pic[1][e][1]
                pic[1][e][1]=i
                puts(handle,pic[1][e][1..3])
            end for
            for e=length(pic[2]) to 1 by -1 do
                puts(handle,pic[2][e])
            end for
        end if
    else
        if index then
            bytes={0,1,9,0,0}&lowhi(length(pic[1]))&24&0&0&0&0&
                lowhi(length(pic[2][1]))&lowhi(length(pic[2]))&8&0
            puts(handle,bytes)
            for e=1 to length(pic[1]) do
                i=pic[1][e][3]
                pic[1][e][3]=pic[1][e][1]
                pic[1][e][1]=i
                puts(handle,pic[1][e][1..3])
            end for
            data={}
            for e=length(pic[2]) to 1 by -1 do
                data=data&pic[2][e]
            end for
            pic={}
            x=2
            last=data[1]
            while 1 do
                if data[x]=last then
                    mode=1
                    c=2
                else
                    bytes={last,data[x]}
                    mode=0
                    c=2
                end if
                while 1 do
                    last=data[x]
                    x=x+1
                    if x=length(data) then exit end if
                    if data[x]=last and mode=1 then
                        c=c+1
                    elsif data[x]!=last and mode=0 then
                        c=c+1
                        bytes=bytes&data[x]
                    else
                        exit
                    end if                
                    if c=127 then
                        exit
                    end if
                end while
                c=c-1
                if mode=1 then
                    puts(handle,128+c)
                    puts(handle,last)
                    last=data[x]
                    x=x+1
                    if x>length(data) then
                        puts(handle,0&x)
                        exit
                    end if
                elsif mode=0 then
                    c=c-1
                    puts(handle,c)
                    puts(handle,bytes[1..c+1])
                    bytes={}
                end if
                if x>=length(data) then
                    exit
                end if
            end while
        end if
    end if
    close(handle)
    return 1
end function


 
